/**
 * Descripteur des spécifications d'un slot de l'agent
 */
package skuad.agentu;

public class PhysicalSpecif {
	String name_slot; 	//nom du slot du device
	int type;		//type du device attendue sur ce slot
	boolean optional;	//si optional==true le plug est optionnelle
	
	public PhysicalSpecif(String vname, int vtype, boolean vopt){
		name_slot = vname;
		type = vtype;
		optional = vopt;
	}
	public PhysicalSpecif(String vname, int vtype){
		name_slot = vname;
		type = vtype;
		optional = false;
	}
	
	public String nameSlot(){ return(name_slot); }
	public int deviceType(){ return(type); }
	public boolean isOptional(){ return(optional); }
}