package skuad.hubudp.implementation;

import java.util.Vector;

public class EContextMember { //instance de description des contextes exécutions connecté à ce hub (utile pour les envoies de message broadcast)
	public Vector<SpotImpl> spots; //ensemble des spots de ce contexte
	boolean is_local_econtext;	
	
	public EContextMember(SpotImpl spot) {
		is_local_econtext = spot.isLocalEContext();
		spots = new Vector<SpotImpl>();
		spots.add(spot);
	}
	
	public void add(SpotImpl spot) { 
		synchronized(spots) { spots.add(spot); }
	}
	public void remove(SpotImpl spot) {
		synchronized(spots) { spots.remove(spot); }
	}
	
	public int count() { return(spots.size()); }
	
	public SpotImpl one() { return(spots.get(0)); }
	
	public boolean isLocalEContext() { return(is_local_econtext); }
	
	public SpotImpl getSpot(int ctarget) {
		synchronized(spots) {
			for(SpotImpl spot : spots) if(spot.getIdLocal()==ctarget) return(spot);
		}
		return(null);
	}
}