package skuad.hubudp.implementation.portal;

import skuad.util.databytes.*;
import skuad.hubudp.implementation.*;

public class SpotPortal extends SpotImpl {
	
	String ip;
	Joiner joiner;
	boolean local_econtext;
	
	public SpotPortal(Joiner vjoin, String vip, int vport, int ct) {
		super(vjoin, ct, vport);
		joiner = vjoin;
		ip = vip;
//System.out.println("-- ipPort : "+ipPort+" // localIpPort : "+joiner.localSpot().getIpPort());		
		local_econtext = joiner.localSpot().getIpPort().equals(getIpPort());
	}	
	public boolean isLocalHost(){ return(false); }
	public String getIp() { return(ip); }
	public boolean isLocalEContext() { return(local_econtext); }
			
 	//[envoie de message vers ce spot
	public boolean isend(SpotSender sender, int channel, byte content, boolean need_ack) {	//-> emission du message ne contenant qu'un byte du spotlocal (sender) vers le spot this
		if(isUp()) {
			joiner.sendTo(this, need_ack, channel, content);
			return(true);
		}
		return(false);
	}	
	public boolean isend(SpotSender sender, int channel, DataReader content, boolean need_ack, boolean auto_dispose) { //du spotlocal (sender) vers le spot this
		if(isUp()) {
			joiner.sendTo(this, need_ack, channel, content);
			if(auto_dispose) content.dispose();
			return(true);
		}
		return(false);
	}	
	public boolean isend(SpotSender sender, int channel, byte[] buff , int offset, int size, boolean need_ack) {	//du spotlocal (sender) vers le spot this
		if(isUp()) {			
			joiner.sendTo(this, need_ack, channel, buff , offset, size);
			return(true);
		}
		return(false);
	}	
	//]
}