package skuad.sim;

import skuad.util.time.Pulse;
import skuad.sim.simop.*;

public interface Pulsable{
	
	public void start(SimPilot sim_pilot, PulsableDescriptor pdesc, StartSimOperation ssop);	//la simulation démarre 
		//elle peut déjà l'être si l'instance pulsable est créée aprés le démarrage de la simulation  
	public void stop(SimPilot sim_pilot);	//fait suite à l'arrêt de la simulation, ou le désenregistrement du pulsable

	//Exécution du comportement du pulsable
	public void behavior(SimPilot sim_pilot, PulsableDescriptor pdesc, Pulse pulse, StartSimOperation ssop, RunSimOperation rsop);	

}