/**
 * Descripteur d'un pulse (unité d'activation temporelle)
 */
package skuad.util.time;

public interface Pulse {
	
	public boolean is(String label);
	public String label();
	public boolean isLoop();		//true ssi c'est une pulsation périodique 
	
	public boolean isActive();
	public int count();				//nombre de fois que ce pulse à conduit à une activation
	public boolean cancel(); 		//annule la répétition cyclique de ce pulse
	
	public void setFilter(TimeFilter tf);	//change le filtre d'activation de ce pulse, si tf=null cela revient à supprimer le filtre
}