package skuad.util.value;

import skuad.util.value.Value;
import skuad.util.value.ValueReader;
import skuad.util.value.ValueWriter;

public abstract class ValueWriter extends ValueReader {
	
	public abstract void setDescription(String m);
	
	//Ecriture de la valeur Atomique
	public abstract ValueWriter set(String val);
	public abstract ValueWriter set(int val);
	public abstract ValueWriter set(float val);
	public abstract ValueWriter set(boolean val);
	public abstract ValueWriter set(byte[] val);

	//[Ecriture de la valeur ARRAY 
	public abstract ValueWriter add(Value val);
	public abstract ValueWriter add(String val);
	public abstract ValueWriter add(int val);
	public abstract ValueWriter add(float val);
	public abstract ValueWriter add(boolean val);
	public abstract ValueWriter add(byte[] val);
	
	public abstract ValueWriter set(int pos, Value val);
	public abstract ValueWriter set(int pos, String val);
	public abstract ValueWriter set(int pos, int val);
	public abstract ValueWriter set(int pos, float val);
	public abstract ValueWriter set(int pos, boolean val);
	public abstract ValueWriter set(int pos, byte[] val);
	
	public abstract ValueWriter remove(int pos);
	public abstract ValueWriter removeAll();
	//]	
	//[Ecriture de la valeur HASH	
	public abstract ValueWriter set(String etq, Value val);
	public abstract ValueWriter set(String etq, String val);
	public abstract ValueWriter set(String etq, int val);
	public abstract ValueWriter set(String etq, float val);
	public abstract ValueWriter set(String etq, boolean val);
	public abstract ValueWriter set(String etq, byte[] val);
	
	public abstract ValueWriter remove(String etq);
	//public abstract ValueWriter removeAll();
	//]
}