/*
 * Implémentation de base d'une Value 
 */
package skuad.util.value.implementation;
import skuad.util.value.Value;

public abstract class BaseValue extends Value {
	protected byte type;
	protected String description;
	
	public BaseValue(byte t, String d){ type=t; if(d==null) d=""; description=d;}
	//[Analyse du type 
	public byte getType(){ return(type); }
	public boolean isAtome(){ return(type==STRING || type==INT || type==BOOL || type==FLOAT || type==BYTES); }
	public boolean isArray(){ return(type==ARRAY); }
	public boolean isHash(){ return(type==HASH); }
	public String description(){ return(description); }
	//]
	
	//[Lecture de valeur
		//[si type est un ATOME (STRING, INT, BOOL, FLOAT, BYTES)
//	public String toString(){ return(null); }
	public int toInt(){ return(0); }
	public boolean toBool(){ return(false); }
	public float toFloat(){ return(0); }
	public byte[] toBytes(){ return(null); }
	
		//]
		//[si type==ARRAY
	public boolean exist(int p){ return(false);}	
	public int size(){ return(0); }
	public Value get(int p){ return(ERROR_VALUE); }
			//accesseur ARRAY rapide
	public String getString(int p){ return(null); }
	public int getInt(int p){ return(0); }
	public boolean getBool(int p){ return(false); }
	public float getFloat(int p){ return(0); }
	public byte[] getBytes(int p){ return(null); }
		//]	
		//[si type==HASH	
	//public int size();
	public Value get(String p){ return(ERROR_VALUE); }
	public Iterable<String> keys(){ return(null); }
	public boolean exist(String p){ return(false);}
			//accesseur HASH rapide
	public String getString(String p){ return(null); }
	public int getInt(String p){ return(0); }
	public boolean getBool(String p){ return(false); }
	public float getFloat(String p){ return(0); }
	public byte[] getBytes(String p){ return(null); }
		//]
	//]

	public abstract Value toConstant();	
}