package skuad.agentu;

import skuad.util.value.Value;

public class SensorTarget {
	
	public final static int OK = 1;
	public final static int NO_PLUG = 2;
	
	String label, name_slot;
	int sensor_id;
	
	public SensorTarget(String l, String n, int id) {
		label = l;
		name_slot = n;
		sensor_id = id;
	}
	public String getLabel() { return(label); }
	public String getNameSlot() { return(name_slot); }
	public int getSensorId() { return(sensor_id); }
	
	//Fonction utiles
	public static boolean allOk(SensorTarget[] targets, Value v) {
		if(targets!=null && targets.length>0) {
			if(v==null || !v.isHash()) return(false);
			for(int i=0; i<targets.length; i++) {
				SensorTarget cur = targets[i];
				Value desc = v.get(cur.label);
				if(desc==null || desc.getInt("state")!=OK) return(false);
			}
		}
		return(true);
	}
}