package skuad.agentu.implementation.amanager;

import skuad.agentu.PhysicalPlugRule;
import skuad.ubiquity.space.Space;
import skuad.uda.Device;

public interface RunAgentContext {

	public Space getSpace(String space_name, String space_password);
	
	//[Gestion des devices
	public HostedDevice findDevice(PhysicalPlugRule prule);
	public Device linkDevice(DeviceHoster hoster, HostedDevice hdevice);
	public boolean unlinkDevice(DeviceHoster hoster, HostedDevice hdevice, Device device);
	
	public void performRuleToAnonymousDevice(HostedDevice hdevice); //on doit déclencher l'analyse des règles sur ce device sans nom sur le (ou les) AgentManager
	public void performRuleToNamedDevice(HostedDevice hdevice);  //on doit déclencher l'analyse des règles sur ce device sans nom sur le (ou les) AgentManager
	//]
	
	public boolean canRunAgent();
	public long getCurrentTime();
}