package skuad.hubudp;

import skuad.util.value.Value;

/**
 * TagReader is the object that has to handle <i>TAGs</i> reading.
 * @see Spot
 */
public interface TagReader {
	
	/**
	 * Read the value of the <i>TAG</i>.
	 * @param spot The <i>Spot</i> which has the TAG.
	 * @param tag_name The <i>TAG</i> that you want to read.
	 * @param tag_vals The value that you want to read.
	 */
	public void tagValues(Spot spot, String tag_name, Value[] tag_vals); 
	
}