package skuad.hubudp.implementation;

public class ProtocoleSpot {
	
	//[Protocole spot (NB: dans ce protocole seules les commandes SET_ID_CONTEXT et SMD sont autorisées en mode d'envoi broadcast)
	//code de statut pour les acuqitements de message
	public final static byte OK 				= 44; 	
	public final static byte TARGET_NOT_EXIST 	= 45;
/*	public final static byte NO_MANAGER = 3;	//aucun manager pour le code protocole utilisé par le message
*/	
	//Code protocole -1
	public final static byte ACK 			= 46; //[58][ACK](short: ack)(short: your_rinstance)[status]		<- aquittement de réception d'un paquet reçu par l'émetteur de cet acquittement
	public final static byte PART 			= 47; //[PART](int : num)(int : total)[channel]{...content_part...}	<- paquet à recomposer (acquitement obligatoire)
	public final static byte BROADCAST 		= 48; //[BROADCAST][X][Y]{...content_part...} , si X == PROTO_SPOT ->pas de Y, sinon si X = PROTO_APP -> Y = channel
	public final static byte GET 			= 49; //[58][GET]
	
	public final static byte SMD 				= 50; //[SMD][def_version](i: nb_value)|...pour chaque valeur: (i: code)[value_size]{...value...}...|
	public final static byte ID_CONTEXT_LIST 	= 51; //[ID_CONTEXT_LIST](int: nb_id_context)|...pour chaque id: (string: chaine_context)(string: id_context) ...| 
	public final static byte SET_ID_CONTEXT  	= 52; //[SET_ID_CONTEXT](string: chaine_context)(string: id_context)  --> en cas d'affectation ou de changement de valeur de l'idContext
	public final static byte ALL_ID_CONTEXT  	= 53; //[ALL_ID_CONTEXT](int: nb_id_context)|...pour chaque id: (string: chaine_context)(string: id_context) ...| <- émis lors de la réception d'une commande GET
	
	public final static byte GET_TAG 		= 54;  //[GET_TAG](string: name)
	public final static byte TAG_VALUE 		= 55; //[TAG_VALUE](string: name)(int: count)...|pour chaque valeur: (value: v)|...
	//]
}