package skuad.hubudp.implementation;

import skuad.hubudp.MessageReceiver;
import skuad.hubudp.Spot;
import skuad.util.databytes.DataReader;
import skuad.util.thread.ThreadStack;

public class RunnerManager implements Runnable {
	MessageReceiver manager; Spot sender; DataReader message; int protocole;
	
	public RunnerManager(MessageReceiver ma, Spot se, int pr, DataReader me) {
		 manager = ma;
		 sender = se;
		 message = me.cloneRest();
		 protocole = pr;
		 
		 ThreadStack.perform(this);
	}
	
	public void run() {
		manager.receive(sender, message, protocole);
	}
}