package skuad.hubudp.implementation;

public class ValueSMD { //{code: length: value: [string:]}
	//Constante de type
	public final static int NUMBER = 0;
	public final static int BUFFER = 1;
	public final static int STRING = 2;
	
	public int code;
	public int type;	//== 0 -> number, 1 -> buffer, 2-> String
	public int num_value;
	public String st_value;
	public byte[] buffer_value;
	
	public ValueSMD(int vc, int v){ //-> type number
		code=vc;
		type=NUMBER;
		num_value=v;
	}
	
	public ValueSMD(int vc, String v){ //-> type String
		code=vc;
		type=STRING;
		st_value=v;
	}
	
	public ValueSMD(int vc, byte[] v){ //-> type Buffer
		code=vc;
		type=BUFFER;
		if(v==null) buffer_value=null;
		else {
			int length = Math.min(v.length, 250);
			buffer_value = new byte[length];
			for(int i=0; i<length; i++) buffer_value[i] = v[i];
		}
	}
	
	public boolean isSameBuffer(byte[] buff) {
		if(type!=BUFFER) return(false);
		if(buff==null && buffer_value==null) return(true);
		if(buff==null || buffer_value==null) return(false);
		int length = Math.min(buff.length, 250);
		if(buffer_value.length==length) {
			for(int i=0; i<length; i++) if(buffer_value[i]!= buff[i]) return(false);
		}
		return(true);
	}
}