package skuad.hubudp.implementation.local;

import java.net.DatagramPacket;
import java.net.*;

public class SocketListener extends Thread {
	
	boolean in_run;
	DatagramSocket socket;
	UdpKernel uKernel;
	
	public SocketListener(UdpKernel vukernel, DatagramSocket vsocket){
		in_run = false;
		uKernel = vukernel;
		socket = vsocket;
	}
	
	public void run(){ // processus d'écoute UDP
		in_run=true;
		byte[] buff = new byte[ProtocoleLocal.MAX_UDP_BUFFER_SIZE];
		DatagramPacket data=new DatagramPacket(buff,buff.length);
		
		int loop_error_count=0; //nombre d'erreur concécutive sur l'écoute de la socket, au dela de 20 l'écoute est interrompu !
		
		while(in_run){
			try{ socket.receive(data); }catch(Exception e) { loop_error_count++; e.printStackTrace(); if(loop_error_count<20) continue; else break; }	
			loop_error_count=0;
			uKernel.performPacket(socket, data, buff);		
		}
		in_run=false;		
	}
}