package skuad.ubiquity.space;

import skuad.ubiquity.space.activity.*;
import skuad.ubiquity.space.alias.*;
import skuad.ubiquity.space.mailbox.*;
import skuad.ubiquity.space.skill.*;
import skuad.ubiquity.space.state.*;
import skuad.util.value.Value;

public class FullParticipantListener implements SkillListener, MessageListener, ActivityListener, AliasListener, StateListener, ParticipantListener {

	public FullParticipantListener(){}
	
	//[Interface MessageListener
	public void receive(MailBox box, Message mess){}
	//]
	
	//[Interface SkillListener
	public void skillAdded(Participant rbody, String newSkill) {} 
	public void skillRemoved(Participant rbody, String lostSkill) {}
	//]
	
	//[Interface PartcipantListener
	public void participantAdded(Participant participant){}
	public void participantRemoved(Participant participant){}
	//]
	
	//[Interface ActivityListener
	public void activityAdded(Participant participant, String newActivity){}
	public void activityRemoved(Participant participant, String lostActivity){}
	public void activityModeChange(Participant participant, String id_activity, byte old_mode, byte new_mode){}
	public void activityStatusChange(Participant participant, String id_activity, byte old_status, byte new_status){}
	public void activityProgressChange(Participant participant, String activity, int currentStep, int maxStep){}
	//]
	
	//[Interface StateListener
	public void stateChange(Participant participant, String field, Value oldValue, Value newValue){}
	//]
	
	//[Interface AliasListener
	public void aliasAdded(Participant identity, String newAlias, int priority){}
	public void aliasRemoved(Participant identity, String lostAlias, int oldPriority){}
	public void aliasPriorityChange(Participant identity, String alias, int oldPriority, int newPriority){}
	public void aliasFocusChange(Participant rbody, String alias, boolean oldFocus, boolean newFocus){}	
	//]
}