package skuad.util.gui;

import java.awt.*;
import javax.swing.*;

public interface HaveGUI {
	
	public final static Color TAB_COLOR[] = {Color.yellow, Color.red, Color.green, Color.blue};
	
	public JComponent getGUI();
	
	public static JFrame FrameFor(HaveGUI thegui, String title, boolean exit_on_close){
		JFrame frame = new JFrame(title);
		frame.setLocation(100,100); 
		if(exit_on_close) frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container pane = frame.getContentPane();
		pane.setLayout(new BorderLayout());
		pane.add(BorderLayout.CENTER, thegui.getGUI());
	
		frame.pack();
		frame.setVisible(true);
		return(frame);		
	}
}