package skuad.util.gui.XYLayout;

import java.io.Serializable;
	
@SuppressWarnings("serial")
public class Pos implements Cloneable, Serializable {

	int x;
	int y;
	int width;
	int height;

	public Pos() {
		this(0, 0, 0, 0);
	}

	public Pos(int x, int y, int width, int height) {
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	}

	public static Pos d(int x, int y){
		return(new Pos(x,y,-1,-1));
	}
	public static Pos d(int x, int y, int width, int height){
		return(new Pos(x,y,width,height));
	}
	
	public int getX() {
		return x;
	}

	public void setX(int x) {
		this.x = x;
	}

	public int getY() {
		return y;
	}

	public void setY(int y) {
		this.y = y;
	}

	public int getWidth() {
		return width;
	}

	public void setWidth(int width) {
		this.width = width;
	}

	public int getHeight() {
		return height;
	}

	public void setHeight(int height) {
		this.height = height;
	}

	public int hashCode() {
		return x ^ y * 37 ^ width * 43 ^ height * 47;
	}

	public boolean equals(Object that) {
		if (that instanceof Pos) {
			Pos other = (Pos) that;
			return other.x == x && other.y == y && other.width == width && other.height == height;
		} else {
			return false;
		}
	}

	public Object clone() {
		return new Pos(x, y, width, height);
	}

	public String toString() {
		return String.valueOf(String.valueOf((new StringBuffer("Pos[")).append(x).append(",")
				.append(y).append(",").append(width).append(",").append(height).append("]")));
	}
}