/*
 * Value de type BOOL constante
 */
package skuad.util.value.implementation;

import skuad.util.value.Value;

public class CBoolValue extends CIntValue {
	
	public final static CBoolValue TRUE = new CBoolValue(true, "Universal TRUE");
	public final static CBoolValue FALSE = new CBoolValue(false, "Universal FALSE");
	
	public CBoolValue(boolean b, String desc){ super((b?1:0), desc);  type=Value.BOOL; }
	public CBoolValue(boolean b){ super((b ? 1 : 0),null);  type=Value.BOOL; }
	public CBoolValue(int v){ super(v,null);  type=Value.BOOL; }
	public CBoolValue(int v, String desc){ super(v,desc);  type=Value.BOOL; }
	public CBoolValue(String st_val, String desc){ super((st_val!=null && !st_val.equals("0") && !st_val.equalsIgnoreCase("false")?1:0),desc);  type=Value.BOOL; }
	 
	//[Complément à BaseValue
	  //[lecture de l'atome (STRING, INT, BOOL)
		public String toString(){ return(val!=0?"true":"false"); }
	  //]
	//]
}