/*
 * Value de type FLOAT constante
 */
package skuad.util.value.implementation;

import skuad.util.value.Value;

public class CFloatValue extends BaseValue {
	float val;
	String st_val;
	
	public CFloatValue(float f){ super(FLOAT,null); val=f; st_val=null; }
	public CFloatValue(float f, String desc){ super(FLOAT, desc); val=f; st_val=null; }
	public CFloatValue(String v, String desc){ 
		super(FLOAT, desc); 
		try { val=Float.parseFloat(v); } catch(Exception e){ val=-1; } 
		st_val=null; 
	}
	
	//[Complément à BaseValue
	  //[lecture de l'atome (STRING, INT, BOOL)
		public String toString(){ if(st_val==null) st_val=String.valueOf(val); return(st_val);}
		public int toInt(){ return((int) val); }
		public boolean toBool(){ return(val!=0); }
		public float toFloat(){ return(val); }
	  //]
	public Value toConstant() { return(this); }	
	public boolean equals(Value v){
		return(v!=null && v.isAtome() && val==v.toFloat());
	}
	//]
}