package skuad.util.value.implementation;

import java.util.*;

import skuad.util.value.Value;

public class CHash extends BaseValue {

	protected Hashtable<String,Value> content;
	
	public CHash(){
		super(HASH,null);
		content=new Hashtable<String,Value> ();
	}
	public CHash(Hashtable<String,Value> v){
		super(HASH, null);		
		content=v;
	}
	@SuppressWarnings("unchecked")
	public CHash(Hashtable<String,Value> v, String desc){
		super(HASH, desc);		
		content=(Hashtable<String,Value>) v.clone();
/*System.out.println(this.hashCode());
System.out.println("CHash size = "+content.size());	
for(String key : content.keySet()) {
	System.out.println("CHash ["+key+"] = "+content.get(key).toString());
}*/
	}	
	//[Complément à BaseValue
			//[lecture du Hash
		public int size(){ return(content.size()); }
		public Value get(String p){ 			
			Value rep=content.get(p);
/*System.out.println(this.hashCode()+ " size = "+content.size());	
for(String key : content.keySet()) {
	System.out.println("CHash ["+key+"] = "+content.get(key).toString());
}
System.out.println("CHash -> ["+p+"] = "+(rep!=null));	
*/			return((rep==null?Value.UNDEFINED_VALUE:rep));
		}
		public Iterable<String> keys(){ return(content.keySet()); }
		public boolean exist(String p){ return(content.containsKey(p));}
				//accesseur HASH rapide	
		public String getString(String p){ return(get(p).toString()); }
		public int getInt(String p){ return(get(p).toInt()); }
		public boolean getBool(String p){ return(get(p).toBool()); }
		public float getFloat(String p){ return(get(p).toFloat()); }
		public byte[] getBytes(String p){ return(get(p).toBytes()); }
			//]	
	public Value toConstant() { return(this); }	
	public String toString(){
		StringBuffer rep=new StringBuffer("{ ");
		boolean first = true;
		synchronized(content) { for(String k : content.keySet()) {
			if(first) first=false;
			else rep.append(" , ");
			rep.append('"').append(k).append("\" : ");
			rep.append(content.get(k).toString());
		} }
		rep.append(" }");
		return(rep.toString()); 
	}
	public boolean equals(Value v){
		if(v!=null && v.isHash() && v.size()==content.size()){
			synchronized(content) { for(String k : keys()) if(!get(k).equals(v.get(k))) return(false); }
			return(true);
		}
		return(false);
	}	
	//]
}