package test.sim.agent;

import skuad.util.time.UT;
import skuad.agentu.AgentUDescriptor;
import skuad.util.time.Pulse;
import skuad.agentu.util.AgentUAdapter;

public class HelloAgent extends AgentUAdapter {
	public final static String physical_specif = ""; 	//aucun slot physique
	public final static String social_specif = ""; 		//aucun slot social

	int n;
	
	//Initialisation de l'agent
	public void start(AgentUDescriptor aud, int ctx){	//invoqué au démarrage de l'agent
		aud.loopPulse("say hello", UT.timeLeft(aud.curTime(), "8h00"), UT.day(1), true); 	//Définition du comportement temporel de l'agent
	}

	public void behavior(AgentUDescriptor aud, Pulse pulse){ //exécute le comportement de l'agent suite à l'activation d'un pulse, pulse = le descripteur de la pulsation qui a initié cet appel
		if(pulse.is("say hello")) aud.log("Hello Agent ! ("+(n++)+")");
	}
}	